--variables
particleTimer = 0
spawnTimer = 0
gravityTimer = 0
escPress = true
f1press = true
jumpOnce = true
quitTimer = 0
menupress = true
canHit = true
slidertimer = 0
staticTimer = 27.1
resetTimer = 0
pressReset = false
areYouSure = false
keySnap = true
skipTimer = 0
deathCounter = 0
deathCounterMax = 50
toggleControlOptionsTimer = 0
recStartPos = false
colbounce = false

--Tables
files = {savedLevel = love.filesystem.read('saves.txt'), dir = love.filesystem.getSaveDirectory( )}
menu = {selected = 0, page = 0, right = 0}
utility = {spawnX = 100, spawnY = 0, endX = 1100, endY = 200-90, endRot = 0, endLocked = false}
player = {x = utility.spawnX, y = utility.spawnY, xshadow = utility.spawnX, yshadow = utility.spawnY, width = 12, height = 12, speed = 300, gravity = 350, jump = 0, jumpOnce = true, switchedGravity = false, gravityTimer = 0, switch = 1, canSwitch = true, offset = 0, r = 20, g = 200, b = 20}
music = {song1loopMax = 3*60+52, song1loopTimer = 0}
color = {pulse = 0.7, pulseDir = 1}
col = {left = true, right = true, up = true, down = true, hit = false}
level = {r = 0, g = 50, b = 0, br = 20, bg = 210, bb = 20, current = 0, switch = true, timer = 1}
vortex = {rot = 0, rotSpeed = 360, scale = 0.003, circlescale = 1, circleDir = 0, fadeBlack = 0, endfade = 0}
options = {fullscreen = false, volume = 0.6, layout = 0, control = true}
env = {}
bgSprites = {}
particles = {}
keys = {}


newBlock = {x = 1000, y = 200, width = 300, height = 720,r = 100, b = 20, g = 200} table.insert(env, newBlock)
newBlock = {x = 0, y = 600, width = 1280, height = 200,r = 100, b = 20, g = 200} table.insert(env, newBlock)
newBlock = {x = 300, y = 200, width = 200, height = 100,r = 100, b = 20, g = 200} table.insert(env, newBlock)

--functions
function reset()
	keys = {}
	env = {}
	level.timer = 1
	level.switch = false
	particles = {}
	player.switch = 1
	newBlock = {x = 2000, y = 2000, width = 1, height = 1, hurt = true, r = level.br, g = level.bg, b = level.bb} table.insert(env, newBlock)
	spawnTimer = 5
end
function restart()
	if player.gravity > 0 then
		newParticle = {x = player.x+10, y = player.y+10, xdir = math.random(-17,17)/100, ydir = math.random(-17, -13)/20, alpha = 255, rot = math.random(-15, 15), id = 2} table.insert(particles, newParticle)
	else
		newParticle = {x = player.x+10, y = player.y+10, xdir = math.random(-17,17)/100, ydir = math.random(17, 13)/20, alpha = 255, rot = math.random(180-15, 180+15), id = 2} table.insert(particles, newParticle)
	end
	x = 30
		while x > 0 do
			newParticle = {x = player.x+10, y = player.y+10, xdir = math.random(20,-20)/10, ydir = math.random(20, -20)/10, alpha = 255, rot = math.random(0, 360), id = 3} table.insert(particles, newParticle)
			x = x - 1
		end
	
	if hasStarted then
		love.audio.play(hit2)
		deathCounter = deathCounter + 1
	end

	for i, block in pairs(env) do
		if block.speed > 0 then
			block.x = block.xpstart
			block.y = block.ypstart
		
			--if block.ydir == 0 then
			--	block.y = block.ylast
			--elseif block.ydir == 1 then
			--	block.y = block.ystart
			--end
			
			--if block.xdir == 0 then
			--	block.x = block.xlast
			--elseif block.xdir == 1 then
			--	block.x = block.xstart
			--end
			
			if block.red2 then
				block.x = 1280/2-50
			end
		end
	end
	player.x = utility.spawnX
	player.y = utility.spawnY
	player.gravity = 350
	level.timer = 1
	player.switchedGravity = true
	jumpOnce = false
	player.switch = 1
	utility.endLocked = true
	keys = {}
	table.insert(keys, newKey)
	spawnTimer = 5
end


function fillBackground(a)
	while a > 0 do
		randomX = math.random(-100, 1400)
		randomY = math.random(0, 720)
		randomSpeed = math.random(10, 20)/10
		randomColor = math.random(9, 11)/10
		randomRot = math.random(-15, 15)
		randomSize = math.random(7,14)/10
		randomRotSpeed = math.random(-2, 2)
		if math.random(1,2) == 1 then
			small = true
		else
			small = false
		end
		if math.random(0, 40) > 39 then
			randomCircle = true
		else
			randomCircle = false
		end
		newSprite = {x = randomX, y = randomY, isSmall = small, isCircle = randomCircle, growDir = 0, width = 50*randomSize, height = 50*randomSize, speed = randomSpeed, rot = randomRot, rotSpeed = randomRotSpeed, randomNumber = randomColor, r = level.r*randomColor, b = level.b*randomColor, g = level.g*randomColor} table.insert(bgSprites, newSprite)
		a = a - 1
	end
end

function collision(x1,y1,h1,w1,x2,y2,h2,w2)
	return x1 < x2+w2 and
		   y1 < y2+h2 and
		   x2 < x1+w1 and
		   y2 < y1+h1
end

function love.load(arg)
love.mouse.setVisible(false)

if love.filesystem.read('controls.txt') == nil then
	love.filesystem.write('controls.txt', 0)
	controlSave = love.filesystem.read('controls.txt')
	print('No control save found, created new default file')
end
if love.filesystem.read('volume.txt') == nil then
	love.filesystem.write('volume.txt', options.volume)
	volumeSave = love.filesystem.read('volume.txt')
end
if controlSave == nil then
	controlSave = love.filesystem.read('controls.txt')
end
if volumeSave == nil then
	volumeSave = love.filesystem.read('volume.txt')
end
options.layout = tonumber(controlSave)
options.volume = tonumber(volumeSave)



--startfunctions
	fillBackground(170)
--loadtextures
	endgate = love.graphics.newImage('assets/endgate.png')
	endgateLocked = love.graphics.newImage('assets/endgate-locked.png')
	startPipe = love.graphics.newImage('assets/startpipe.png')
	particle1 = love.graphics.newImage('assets/particle1.png')
	particle2 = love.graphics.newImage('assets/particle2.png')
	particle3 = love.graphics.newImage('assets/particle3.png')
	particle4 = love.graphics.newImage('assets/particle4.png')
	keyImg = love.graphics.newImage('assets/key.png')
	rect = love.graphics.newImage('assets/rect.png')
	wasd = love.graphics.newImage('assets/text/wasd.png')
	jumpImg = love.graphics.newImage('assets/text/jump.png')
	jump1Img = love.graphics.newImage('assets/text/jump1.png')
	gravityImg = love.graphics.newImage('assets/text/gravity.png')
	gravity1Img = love.graphics.newImage('assets/text/gravity1.png')
	switchImg = love.graphics.newImage('assets/text/switch.png')
	switch1Img = love.graphics.newImage('assets/text/switch1.png')
	vortexImg = love.graphics.newImage('assets/vortex.png')
	shadeImg = love.graphics.newImage('assets/shade.png')
	endImg = love.graphics.newImage('assets/text/end.png')
	playImg = love.graphics.newImage('assets/text/play.png')
	continueImg = love.graphics.newImage('assets/text/continue.png')
	controlImg = love.graphics.newImage('assets/text/control.png')
	optionsImg = love.graphics.newImage('assets/text/options.png')
	controls1Img = love.graphics.newImage('assets/text/controls1.png')
	logo = love.graphics.newImage('assets/text/logo.png')
	secondesc = love.graphics.newImage('assets/text/secondesc.png')
	arrow = love.graphics.newImage('assets/arrow.png')
	controlsImg = love.graphics.newImage('assets/text/controls.png')
	overlayImg = love.graphics.newImage('assets/overlay.png')
	resetImg = love.graphics.newImage('assets/text/reset.png')
	sureImg = love.graphics.newImage('assets/text/sure.png')
	savingImg = love.graphics.newImage('assets/text/saving.png')
	pressselect = love.graphics.newImage('assets/text/pressselect.png')
	changeImg = love.graphics.newImage('assets/text/change.png')
	skipImg = love.graphics.newImage('assets/text/skip.png')
	--audio
	hit1 = love.audio.newSource('assets/audio/hit1.wav')
	hit2 = love.audio.newSource('assets/audio/hit2.mp3')
	select = love.audio.newSource('assets/audio/select.wav')
	start = love.audio.newSource('assets/audio/start.wav')
	back = love.audio.newSource('assets/audio/back.wav')
	keySound = love.audio.newSource('assets/audio/key.wav')
	staticNoise = love.audio.newSource('assets/audio/static.mp3')
	song1 = love.audio.newSource('assets/audio/music.mp3')
--require .lua-files
	require('bin/menu')
	require('bin/input')
	require('bin/env')
	require('bin/player')
	require('bin/bgSprites')
	require('bin/levels')
	require('bin/particles')
	require('bin/key')
	require('bin/music')

	
end


local t = 0
function love.update(dt)
colbounce = false

love.audio.setVolume(options.volume)
love.window.setFullscreen(options.fullscreen, "desktop")
--Nils
	if utility.endRot == nil then
		utility.endRot = 0
	end
	if not love.filesystem.exists('saves.txt') then
		files.savedLevel = love.filesystem.newFile('saves.txt')
		love.filesystem.write('saves.txt', 1)
		print('Created new savefile')
	end
--write level data
	--print(love.filesystem.read("saves.txt"))
	files.savedLevel = love.filesystem.read('saves.txt')
	if tonumber(files.savedLevel) < 1 then
		files.savedLevel = 1
	end

--Update Timer	
	hdt = dt
	vortex.rot = vortex.rot + (vortex.rotSpeed*hdt)
	particleTimer = particleTimer + (1*hdt)
	spawnTimer = spawnTimer - (1*hdt)
	gravityTimer = gravityTimer -(1*hdt)
	level.timer = level.timer - (1*hdt)
	staticTimer = staticTimer + hdt
	slidertimer = slidertimer - hdt
	resetTimer = resetTimer - hdt
	menu.right = menu.right + (40*hdt)
	toggleControlOptionsTimer = toggleControlOptionsTimer + hdt
	--updatetimerpulsesDir
	if toggleControlOptionsTimer > 1 then
		if options.control then
			options.control = false
		else
			options.control = true
		end
		toggleControlOptionsTimer = 0
	end
	if skipTimer < 0 then
		skipTimer = 0
	end
	if options.layout > 1 then
		options.layout = 0
	elseif options.layout < 0 then
		options.layout = 1
	end
	if menu.right > 1280/3 then
		menu.right = 0
	end
	if level.timer < 0 and isSaving then
		isSaving = false
	end
	if menu.page == 0 and tonumber(files.savedLevel) > 1 then
		if menu.selected > 2 then
			menu.selected = 0
		end
		if menu.selected < 0 then
			menu.selected = 2
		end

	elseif menu.page == 0 then
		if menu.selected > 1 then
			menu.selected = 0
		end
		if menu.selected < 0 then
			menu.selected = 1
		end
	end
	if options.volume > 1 then
		options.volume = 1
	elseif options.volume < 0 then
		options.volume = 0
	end
	--if level.current == 0 and menu.page == 0 and quitTimer > 0.4 then
	--	quitTimer = 1.4
	--end
	if quitTimer > 0 then
		quitTimer = quitTimer - (1*hdt)
	end
	if quitTimer < 0 then
		quitTimer = 0
	end
	if vortex.scale > 400 then
		utility.spawnX = 20000
		canGrav = false
		player.gravity = 350
		player.offset = player.offset + (10*hdt)
	else
		player.offset = 0
		canGrav = true
	end
	if vortex.circlescale > 1.1 then
		vortex.circleDir = 0
	elseif vortex.circlescale < 1 then
		vortex.circleDir = 1
	end
	if level.current == 21 then
		love.audio.stop(song1)
		vortex.scale = vortex.scale + (15*hdt)
		love.filesystem.write('saves.txt', 1)
	end
	if vortex.scale > 50 then
		vortex.fadeBlack = vortex.fadeBlack + (20*hdt)
	end
	if vortex.scale > 65 then
		vortex.fadeBlack = vortex.fadeBlack + (75*hdt)
	end
	--updatetimerpulses
	if vortex.circleDir == 0 then
		vortex.circlescale = vortex.circlescale - (0.015*hdt)
	else
		vortex.circlescale = vortex.circlescale + (0.015*hdt)
	end

--Update functions
	updateMenu()
	updateInput()
	updateEnv()
	updatePlayer()
	updateBgSprites()
	updateLevels()
	updateParticles()
	updateKey()
	updateMusic()
	
	if player.hitGround2 then
		player.jump = 0
	end
	player.hitGround2 = false
end

function love.draw(dt)

love.graphics.setShader(new,draw,set)

--set Scale
	love.graphics.scale(love.graphics.getWidth()/1280, love.graphics.getHeight()/720)
	
-- bg thing
	for i, bgSprite in pairs(bgSprites) do
		if bgSprite.isCircle then
			love.graphics.setColor(0, 0, 0, 5)
			love.graphics.circle("fill", bgSprite.x, bgSprite.y, bgSprite.circleRadius, 300)
		end
	end

--set Colors
	love.graphics.setBackgroundColor(level.r*0.65,level.g*0.65,level.b*0.65)
	--color pulse
	if color.pulse > 0.9 then
		color.pulseDir = 0
	elseif color.pulse < 0.7 then
		color.pulseDir = 1
	end
	if color.pulseDir == 1 then
		color.pulse = color.pulse + (0.3*hdt)
	else
		color.pulse = color.pulse - (0.3*hdt)
	end

	--switch and gravity color change

--Draw bgSprites
	for i, bgSprite in pairs(bgSprites) do
		if bgSprite.isCircle == false and bgSprite.isSmall then
			love.graphics.setColor(bgSprite.r*0.8,bgSprite.g*0.8,bgSprite.b*0.8, 100)
			love.graphics.draw(rect, bgSprite.x+5, bgSprite.y+5, math.rad(bgSprite.rot), bgSprite.width/200, bgSprite.height/200, 3,3)
			love.graphics.setColor(bgSprite.r*0.8,bgSprite.g*0.8,bgSprite.b*0.8)
			love.graphics.draw(rect, bgSprite.x, bgSprite.y, math.rad(bgSprite.rot),bgSprite.width/200, bgSprite.height/200, bgSprite.width/100/2, bgSprite.height/100/2)
		elseif bgSprite.isCircle == false and bgSprite.isSmall == false then
			love.graphics.setColor(bgSprite.r*0.85,bgSprite.g*0.85,bgSprite.b*0.85, 100)
			love.graphics.draw(rect, bgSprite.x+5, bgSprite.y+5, math.rad(bgSprite.rot), bgSprite.width/100, bgSprite.height/100, 3,3)
			love.graphics.setColor(bgSprite.r,bgSprite.g,bgSprite.b)
			love.graphics.draw(rect, bgSprite.x, bgSprite.y, math.rad(bgSprite.rot),bgSprite.width/100, bgSprite.height/100, bgSprite.width/100/2, bgSprite.height/100/2)
		end
	end




--Draw endgate
if hasStarted then
	if utility.endLocked == false then
		love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
		love.graphics.draw(endgate, utility.endX - (endgate:getWidth()/2) + (player.width/2) + 2-10, utility.endY-10+10, math.rad(utility.endRot))
		love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
		love.graphics.draw(endgate, utility.endX - (endgate:getWidth()/2) + (player.width/2) + 2-5, utility.endY-10+5, math.rad(utility.endRot))
		love.graphics.setColor(level.br,level.bg,level.bb)
		love.graphics.draw(endgate, utility.endX - (endgate:getWidth()/2) + (player.width/2) + 2, utility.endY-10, math.rad(utility.endRot))
	else
		love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
		love.graphics.draw(endgateLocked, utility.endX - (endgate:getWidth()/2) + (player.width/2) + 2-10, utility.endY-10+10, math.rad(utility.endRot))
		love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
		love.graphics.draw(endgateLocked, utility.endX - (endgate:getWidth()/2) + (player.width/2) + 2-5, utility.endY-10+5, math.rad(utility.endRot))
		love.graphics.setColor(level.br,level.bg,level.bb)
		love.graphics.draw(endgateLocked, utility.endX - (endgate:getWidth()/2) + (player.width/2) + 2, utility.endY-10, math.rad(utility.endRot))
	end
end

	--Draw player shadow
	love.graphics.setColor(player.r*0.5,player.g*0.5,player.b*0.5, 25)
	love.graphics.rectangle("fill", player.x+(player.x-(1280/2))*0.020 -3, player.y+(player.y-(720/2))*0.040 -3, player.width+8, player.height+8)
	love.graphics.setColor(player.r*0.5,player.g*0.5,player.b*0.5, 50)
	love.graphics.rectangle("fill", player.x+(player.x-(1280/2))*0.010 -3, player.y+(player.y-(720/2))*0.020 -3, player.width+8, player.height+8)
	
	--Draw keys
	for i, key in pairs(keys) do
		if key.yplus == nil then
			key.yplus = 0
			key.rot = 0
		end
		love.graphics.setColor(level.br, level.bg, level.bb)
		love.graphics.draw(keyImg, key.x, key.y-(keyImg:getHeight()/2)-key.yplus, math.rad(key.rot), 1, 1, keyImg:getWidth()/2, keyImg:getHeight()/2)
		
		--draw key circle
		love.graphics.setColor(player.r,player.g,player.b, 25/4)
		love.graphics.circle("fill", key.x, key.y-(keyImg:getHeight()/2)-key.yplus, 70*(key.yplus/50)+10*2, 300)
		love.graphics.setColor(player.r,player.g,player.b, 15/4)
		love.graphics.circle("fill", key.x, key.y-(keyImg:getHeight()/2)-key.yplus, 40*(key.yplus/50)+10*2, 300)
		love.graphics.setColor(player.r,player.g,player.b, 7.5/4)
		love.graphics.circle("fill", key.x, key.y-(keyImg:getHeight()/2)-key.yplus, 10*(key.yplus/50)+10*2, 300)
	end
	
--Draw env first part
	for i, block in pairs(env) do
		if block.switch == nil then
			block.switch = 0
		end
			if block.mult == nil then
				block.mult = 0.6
			end
		if block.switch > player.switch or block.switch < player.switch then
			love.graphics.setColor(block.r*block.mult*color.pulse,block.g*block.mult*color.pulse,block.b*block.mult*color.pulse)
			love.graphics.rectangle("fill", block.x, block.y, block.width, block.height)
		end
	end
	for i, block in pairs(env) do
		if block.switch == player.switch or block.switch == 0 then
			if block.detail and block.hurt == true then
				love.graphics.setColor(block.r*0.4,block.g*0.4,block.b*0.4)
				love.graphics.rectangle("fill", block.x-10, block.y+10, block.width, block.height)
				love.graphics.setColor(block.r*0.65,block.g*0.65,block.b*0.65)
				love.graphics.rectangle("fill", block.x-5, block.y+5, block.width, block.height)
			end
		end
	end
	
	--Draw particles 1
	for i, particle in pairs(particles) do
		if particle.id == 0 or particle.id == 0.1 then
			if particle.id == 0 then
				love.graphics.setColor(255,0,0, particle.alpha)
			else
				love.graphics.setColor(0,60,0, particle.alpha)
			end
			love.graphics.draw(particle1, particle.x, particle.y, math.rad(particle.rot), 0.5, 0.5)
		end
		
		if particle.id == 3 then
			love.graphics.setColor(particle.r,0,0,particle.alpha)
			love.graphics.draw(particle4, particle.x, particle.y, math.rad(particle.rot), particle.g*0.2, particle.g*0.2)
		end
	end
	
	--env second part
	for i, block in pairs(env) do
		if block.switch == player.switch or block.switch == 0 then
			if block.detail and block.hurt == false then
				love.graphics.setColor(block.r*0.4,block.g*0.4,block.b*0.4)
				love.graphics.rectangle("fill", block.x-10, block.y+10, block.width, block.height)
				love.graphics.setColor(block.r*0.65,block.g*0.65,block.b*0.65)
				love.graphics.rectangle("fill", block.x-5, block.y+5, block.width, block.height)
			end
			love.graphics.setColor(block.r,block.g,block.b)
			love.graphics.rectangle("fill", block.x, block.y, block.width, block.height)
		end
	end
		
				
		--end

		
	--end
	
	
	
--Draw particles2
	for i, particle in pairs(particles) do
		if particle.id == 1 then
			love.graphics.setColor(player.r,player.g,player.b, particle.alpha)
			love.graphics.draw(particle2, particle.x, particle.y, math.rad(particle.rot), 0.5/2.5, 0.5/2.5)
		end
	end
	for i, particle in pairs(particles) do
		if particle.id == 2 then
			love.graphics.setColor(255,10,10, particle.alpha)
			love.graphics.draw(particle3, particle.x, particle.y, math.rad(particle.rot), 0.5/2.5, 0.5/2.5)
		end
	end

	
--Draw endgate
	if utility.endRot == 180 then
		love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
		love.graphics.draw(endgate, utility.endX - (endgate:getWidth()/2) + (player.width/2) + 2-10, utility.endY-10+10, math.rad(utility.endRot))
		love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
		love.graphics.draw(endgate, utility.endX - (endgate:getWidth()/2) + (player.width/2) + 2-5, utility.endY-10+5, math.rad(utility.endRot))
		love.graphics.setColor(level.br,level.bg,level.bb)
		love.graphics.draw(endgate, utility.endX - (endgate:getWidth()/2) + (player.width/2) + 2, utility.endY-10, math.rad(utility.endRot))
	end

--Draw startPipe
	love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
	love.graphics.draw(startPipe, utility.spawnX - (startPipe:getWidth()/2) + (player.width/2) + 2-10, utility.spawnY-10+10)
	love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
	love.graphics.draw(startPipe, utility.spawnX - (startPipe:getWidth()/2) + (player.width/2) + 2-5, utility.spawnY-10+5)
	love.graphics.setColor(level.br,level.bg,level.bb)
	love.graphics.draw(startPipe, utility.spawnX - (startPipe:getWidth()/2) + (player.width/2) + 2, utility.spawnY-10)


--Draw Player
	love.graphics.setColor(player.r,player.g,player.b)
	love.graphics.rectangle("fill", player.x-3, player.y-3+player.offset, player.width+8, player.height+8)

	--Draw circle on other
		love.graphics.setColor(player.r,player.g,player.b, 2.5/3.5)
		love.graphics.circle("fill", 1280/2-(vortexImg:getWidth()/2)+(vortexImg:getWidth()/2), 720/2-(vortexImg:getHeight()/2)+(vortexImg:getHeight()/2), 170*vortex.circlescale, 300)
		love.graphics.setColor(player.r,player.g,player.b, 5/3.5)
		love.graphics.circle("fill", 1280/2-(vortexImg:getWidth()/2)+(vortexImg:getWidth()/2), 720/2-(vortexImg:getHeight()/2)+(vortexImg:getHeight()/2), 270*vortex.circlescale, 300)
		love.graphics.setColor(player.r,player.g,player.b, 7.5/3.5)
		love.graphics.circle("fill", 1280/2-(vortexImg:getWidth()/2)+(vortexImg:getWidth()/2), 720/2-(vortexImg:getHeight()/2)+(vortexImg:getHeight()/2), 370*vortex.circlescale, 300)
		love.graphics.setColor(player.r,player.g,player.b, 10/3.5)
		love.graphics.circle("fill", 1280/2-(vortexImg:getWidth()/2)+(vortexImg:getWidth()/2), 720/2-(vortexImg:getHeight()/2)+(vortexImg:getHeight()/2), 470*vortex.circlescale, 300)
		love.graphics.setColor(player.r,player.g,player.b, 12.5/3.5)
		love.graphics.circle("fill", 1280/2-(vortexImg:getWidth()/2)+(vortexImg:getWidth()/2), 720/2-(vortexImg:getHeight()/2)+(vortexImg:getHeight()/2), 570*vortex.circlescale, 300)
		love.graphics.setColor(player.r,player.g,player.b, 15/3.5)
		love.graphics.circle("fill", 1280/2-(vortexImg:getWidth()/2)+(vortexImg:getWidth()/2), 720/2-(vortexImg:getHeight()/2)+(vortexImg:getHeight()/2), 670*vortex.circlescale, 300)
		love.graphics.setColor(player.r,player.g,player.b, 17.5/3.5)
		love.graphics.circle("fill", 1280/2-(vortexImg:getWidth()/2)+(vortexImg:getWidth()/2), 720/2-(vortexImg:getHeight()/2)+(vortexImg:getHeight()/2), 770*vortex.circlescale, 300)

--Draw Vortex
		if hasStarted == false then
			love.graphics.setColor(player.r,player.g,player.b)
			love.graphics.draw(vortexImg, 1280/2-(vortexImg:getWidth()/2)+(vortexImg:getWidth()/2), 720/2-(vortexImg:getHeight()/2)+(vortexImg:getHeight()/2)+200, math.rad(vortex.rot), 0.01*(level.current/2), 0.01*(level.current/2), vortexImg:getWidth()/2, vortexImg:getHeight()/2)
		end
			
		if level.current == 21 or level.current == 0 then
		--circle bit
		love.graphics.setColor(player.r,player.g,player.b, 2.5/2)
		love.graphics.circle("fill", 1280/2-(vortexImg:getWidth()/2)+(vortexImg:getWidth()/2), 720/2-(vortexImg:getHeight()/2)+(vortexImg:getHeight()/2), 170*vortex.circlescale, 300)
		love.graphics.setColor(player.r,player.g,player.b, 5/2)
		love.graphics.circle("fill", 1280/2-(vortexImg:getWidth()/2)+(vortexImg:getWidth()/2), 720/2-(vortexImg:getHeight()/2)+(vortexImg:getHeight()/2), 270*vortex.circlescale, 300)
		love.graphics.setColor(player.r,player.g,player.b, 7.5/2)
		love.graphics.circle("fill", 1280/2-(vortexImg:getWidth()/2)+(vortexImg:getWidth()/2), 720/2-(vortexImg:getHeight()/2)+(vortexImg:getHeight()/2), 370*vortex.circlescale, 300)
		love.graphics.setColor(player.r,player.g,player.b, 10/2)
		love.graphics.circle("fill", 1280/2-(vortexImg:getWidth()/2)+(vortexImg:getWidth()/2), 720/2-(vortexImg:getHeight()/2)+(vortexImg:getHeight()/2), 470*vortex.circlescale, 300)
		love.graphics.setColor(player.r,player.g,player.b, 12.5/2)
		love.graphics.circle("fill", 1280/2-(vortexImg:getWidth()/2)+(vortexImg:getWidth()/2), 720/2-(vortexImg:getHeight()/2)+(vortexImg:getHeight()/2), 570*vortex.circlescale, 300)
		love.graphics.setColor(player.r,player.g,player.b, 15/2)
		love.graphics.circle("fill", 1280/2-(vortexImg:getWidth()/2)+(vortexImg:getWidth()/2), 720/2-(vortexImg:getHeight()/2)+(vortexImg:getHeight()/2), 670*vortex.circlescale, 300)
		love.graphics.setColor(player.r,player.g,player.b, 17.5/2)
		love.graphics.circle("fill", 1280/2-(vortexImg:getWidth()/2)+(vortexImg:getWidth()/2), 720/2-(vortexImg:getHeight()/2)+(vortexImg:getHeight()/2), 770*vortex.circlescale, 300)

--Draw endfade
	love.graphics.setColor(0,0,0, vortex.fadeBlack)
	love.graphics.rectangle("fill", 0, 0, 1280, 720)

	end

		-----HUD-----
---level hints
	--level1 hint
	if level.current == 1 and hasStarted then
	love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
	love.graphics.draw(wasd, 1280/2-(wasd:getWidth()/2)-6, 30+6+50)
	love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
	love.graphics.draw(wasd, 1280/2-(wasd:getWidth()/2)-3, 30+3+50)
	love.graphics.setColor(level.br,level.bg,level.bb)
	love.graphics.draw(wasd, 1280/2-(wasd:getWidth()/2), 30+50)
	
	if options.layout == 0 then
	love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
	love.graphics.draw(jumpImg, 1280/2-(jumpImg:getWidth()/2)-6, 30+6+100)
	love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
	love.graphics.draw(jumpImg, 1280/2-(jumpImg:getWidth()/2)-3, 30+3+100)
	love.graphics.setColor(level.br,level.bg,level.bb)
	love.graphics.draw(jumpImg, 1280/2-(jumpImg:getWidth()/2), 30+100)
	else
	love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
	love.graphics.draw(jump1Img, 1280/2-(jump1Img:getWidth()/2)-6, 30+6+100)
	love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
	love.graphics.draw(jump1Img, 1280/2-(jump1Img:getWidth()/2)-3, 30+3+100)
	love.graphics.setColor(level.br,level.bg,level.bb)
	love.graphics.draw(jump1Img, 1280/2-(jump1Img:getWidth()/2), 30+100)
	end
	end
	if level.current == 2 and hasStarted then
	if options.layout == 0 then
	love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
	love.graphics.draw(gravityImg, 1280/2-(gravityImg:getWidth()/2)-6+30, 720-120+6)
	love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
	love.graphics.draw(gravityImg, 1280/2-(gravityImg:getWidth()/2)-3+30, 720-120+3)
	love.graphics.setColor(level.br,level.bg,level.bb)
	love.graphics.draw(gravityImg, 1280/2-(gravityImg:getWidth()/2)+30, 720-120)
	else
	love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
	love.graphics.draw(gravity1Img, 1280/2-(gravity1Img:getWidth()/2)-6+30, 720-120+6)
	love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
	love.graphics.draw(gravity1Img, 1280/2-(gravity1Img:getWidth()/2)-3+30, 720-120+3)
	love.graphics.setColor(level.br,level.bg,level.bb)
	love.graphics.draw(gravity1Img, 1280/2-(gravity1Img:getWidth()/2)+30, 720-120)
	end
	end
	if level.current == 4 and hasStarted then
	if options.layout == 0 then
	love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
	love.graphics.draw(switchImg, 850-switchImg:getWidth()-30-6, 30+6+450)
	love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
	love.graphics.draw(switchImg, 850-switchImg:getWidth()-30-3, 30+3+450)
	love.graphics.setColor(level.br,level.bg,level.bb)
	love.graphics.draw(switchImg, 850-switchImg:getWidth()-30, 30+450)
	else
	love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
	love.graphics.draw(switch1Img, 850-switch1Img:getWidth()-30-6, 30+6+450)
	love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
	love.graphics.draw(switch1Img, 850-switch1Img:getWidth()-30-3, 30+3+450)
	love.graphics.setColor(level.br,level.bg,level.bb)
	love.graphics.draw(switch1Img, 850-switch1Img:getWidth()-30, 30+450)
	end
	end
	if level.current == 5 and hasStarted then
	love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
	love.graphics.draw(changeImg, changeImg:getWidth()-130-30-6, 720-changeImg:getHeight()-15+6)
	love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
	love.graphics.draw(changeImg, changeImg:getWidth()-130-30-3, 720-changeImg:getHeight()-15+3)
	love.graphics.setColor(level.br,level.bg,level.bb)
	love.graphics.draw(changeImg, changeImg:getWidth()-130-30, 720-changeImg:getHeight()-15)
	end
	if deathCounter > deathCounterMax then
	love.graphics.setColor(30,30,30,80)
	love.graphics.rectangle('fill', 1280/2-skipImg:getWidth()/2-6-10, skipImg:getHeight()-15-10, skipImg:getWidth()+10, skipImg:getHeight()+30)
	
	love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
	love.graphics.draw(skipImg, 1280/2-skipImg:getWidth()/2-6, skipImg:getHeight()-15+6)
	love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
	love.graphics.draw(skipImg, 1280/2-skipImg:getWidth()/2-3, skipImg:getHeight()-15+3)
	love.graphics.setColor(level.br,level.bg,level.bb)
	love.graphics.draw(skipImg, 1280/2-skipImg:getWidth()/2, skipImg:getHeight()-15)
	end
	if level.current == 21 and vortex.scale > 150 then
		if vortex.endfade < 1 then	
			vortex.endfade = vortex.endfade + (0.15*hdt)
		end
	love.graphics.setColor(level.br*0.4*vortex.endfade,level.bg*0.4*vortex.endfade,level.bb*0.4*vortex.endfade)
	love.graphics.draw(endImg, 1280/2-(endImg:getWidth()/2)-30-6, 30+6+150)
	love.graphics.setColor(level.br*0.65*vortex.endfade,level.bg*0.65*vortex.endfade,level.bb*0.65*vortex.endfade)
	love.graphics.draw(endImg, 1280/2-(endImg:getWidth()/2)-30-3, 30+3+150)
	love.graphics.setColor(level.br*vortex.endfade,level.bg*vortex.endfade,level.bb*vortex.endfade)
	love.graphics.draw(endImg, 1280/2-(endImg:getWidth()/2)-30, 30+150)
	end
	if isSaving and level.current > 0 then
		love.graphics.setColor(level.br,level.bg,level.bb, 255*level.timer)
		love.graphics.draw(savingImg, 1280-(savingImg:getWidth()/2)-20, 20,0,0.5)
	end
	if level.current == 0 then
		--play
		if menu.page == 0 and tonumber(files.savedLevel) == 1 then
		love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
		love.graphics.draw(playImg, 1280/2-(playImg:getWidth()/2)-8, 30+8+560)
		love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
		love.graphics.draw(playImg, 1280/2-(playImg:getWidth()/2)-4, 30+4+560)
		love.graphics.setColor(level.br,level.bg,level.bb)
		love.graphics.draw(playImg, 1280/2-(playImg:getWidth()/2), 30+560)
		elseif menu.page == 0 and tonumber(files.savedLevel) > 1 then
		love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
		love.graphics.draw(continueImg, 1280/2-(continueImg:getWidth()/2)-8, 30+8+560)
		love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
		love.graphics.draw(continueImg, 1280/2-(continueImg:getWidth()/2)-4, 30+4+560)
		love.graphics.setColor(level.br,level.bg,level.bb)
		love.graphics.draw(continueImg, 1280/2-(continueImg:getWidth()/2), 30+560)
		end
		--control
		if options.control then
		if menu.page == 0 and tonumber(files.savedLevel) > 1 then
		love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
		love.graphics.draw(controlImg, 1280/2-(controlImg:getWidth()/2)-8, 30+8+370)
		love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
		love.graphics.draw(controlImg, 1280/2-(controlImg:getWidth()/2)-4, 30+4+370)
		love.graphics.setColor(level.br,level.bg,level.bb)
		love.graphics.draw(controlImg, 1280/2-(controlImg:getWidth()/2), 30+370)
		elseif menu.page == 0 then
		love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
		love.graphics.draw(controlImg, 1280/2-(controlImg:getWidth()/2)-8, 30+8+470)
		love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
		love.graphics.draw(controlImg, 1280/2-(controlImg:getWidth()/2)-4, 30+4+470)
		love.graphics.setColor(level.br,level.bg,level.bb)
		love.graphics.draw(controlImg, 1280/2-(controlImg:getWidth()/2), 30+470)
		end
		
		else
		
		if menu.page == 0 and tonumber(files.savedLevel) > 1 then
		love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
		love.graphics.draw(optionsImg, 1280/2-(optionsImg:getWidth()/2)-8, 30+8+370)
		love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
		love.graphics.draw(optionsImg, 1280/2-(optionsImg:getWidth()/2)-4, 30+4+370)
		love.graphics.setColor(level.br,level.bg,level.bb)
		love.graphics.draw(optionsImg, 1280/2-(optionsImg:getWidth()/2), 30+370)
		elseif menu.page == 0 then
		love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
		love.graphics.draw(optionsImg, 1280/2-(optionsImg:getWidth()/2)-8, 30+8+470)
		love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
		love.graphics.draw(optionsImg, 1280/2-(optionsImg:getWidth()/2)-4, 30+4+470)
		love.graphics.setColor(level.br,level.bg,level.bb)
		love.graphics.draw(optionsImg, 1280/2-(optionsImg:getWidth()/2), 30+470)
		end
		end
		--reset
		if menu.page == 0 and tonumber(files.savedLevel) > 1 and areYouSure == false then
		love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
		love.graphics.draw(resetImg, 1280/2-(resetImg:getWidth()/2)-8, 30+8+470)
		love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
		love.graphics.draw(resetImg, 1280/2-(resetImg:getWidth()/2)-4, 30+4+470)
		love.graphics.setColor(level.br,level.bg,level.bb)
		love.graphics.draw(resetImg, 1280/2-(resetImg:getWidth()/2), 30+470)
		end
		--sure?
		if menu.page == 0 and tonumber(files.savedLevel) > 1 and areYouSure then
		love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
		love.graphics.draw(sureImg, 1280/2-(sureImg:getWidth()/2)-8, 30+8+470)
		love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
		love.graphics.draw(sureImg, 1280/2-(sureImg:getWidth()/2)-4, 30+4+470)
		love.graphics.setColor(level.br,level.bg,level.bb)
		love.graphics.draw(sureImg, 1280/2-(sureImg:getWidth()/2), 30+470)
		end
		--pressselect
		if menu.page == 0 then
		love.graphics.setColor(20,20,20,40)
		love.graphics.rectangle('fill',0,720-35,1280,60)
		love.graphics.setColor(level.br,level.bg,level.bb)
		love.graphics.draw(pressselect, 1280/2-(pressselect:getWidth()/4)-2+menu.right, 700-2,0,0.5,0.5)
		love.graphics.draw(pressselect, 1280/2-(pressselect:getWidth()/4)-2+(1280/3)+menu.right, 700-2,0,0.5,0.5)
		love.graphics.draw(pressselect, 1280/2-(pressselect:getWidth()/4)-2-(1280/3)+menu.right, 700-2,0,0.5,0.5)
		love.graphics.draw(pressselect, 1280/2-(pressselect:getWidth()/4)-2-(1280/3*2)+menu.right, 700-2,0,0.5,0.5)
		end
		--arrow 
		if menu.page == 0 and menu.selected == 0 then
			love.graphics.setColor(30,30,30,30)
			love.graphics.rectangle('fill',0, 30+560-10, 1280, continueImg:getHeight()+30)
			love.graphics.setColor(level.br,level.bg,level.bb)
			love.graphics.draw(arrow, 1280/3.2, 30+560, 0, 1, 1)
		elseif menu.page == 0 and menu.selected == 1 then
			love.graphics.setColor(30,30,30,30)
			love.graphics.rectangle('fill',0, 30+470-10, 1280, continueImg:getHeight()+30)
			love.graphics.setColor(level.br,level.bg,level.bb)
			love.graphics.draw(arrow, 1280/3.2, 30+470, 0, 1, 1)
		elseif menu.page == 0 and menu.selected == 2 and tonumber(files.savedLevel) > 1 then
			love.graphics.setColor(30,30,30,30)
			love.graphics.rectangle('fill',0, 30+370-10, 1280, continueImg:getHeight()+30)
			love.graphics.setColor(level.br,level.bg,level.bb)
			love.graphics.draw(arrow, 1280/3.2, 30+370, 0, 1, 1)
		end
		
		
		--logo
		if menu.page == 0 then
			love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
			love.graphics.draw(logo, 1280/2-(logo:getWidth()/6)-8, 30+8, 0, 1/3, 1/3)
			love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
			love.graphics.draw(logo, 1280/2-(logo:getWidth()/6)-4, 30+4, 0, 1/3, 1/3)
			love.graphics.setColor(level.br,level.bg,level.bb)
			love.graphics.draw(logo, 1280/2-(logo:getWidth()/6), 30, 0, 1/3, 1/3)
		end
		
		--controls
		if menu.page == 1 then
			love.graphics.setColor(level.br,level.bg,level.bb)
			love.graphics.setColor(10,10,10,100)
			love.graphics.rectangle('fill', 0, 100, 1280,controlsImg:getHeight()+80)
			
			love.graphics.setColor(level.br,level.bg,level.bb)
			love.graphics.draw(arrow, 1280-10-arrow:getWidth(), 720/2, 0, 1, 1)
			love.graphics.draw(arrow, 1280-20-arrow:getWidth(), 720/2+arrow:getHeight(), math.rad(180), 1, 1)
			
		if options.layout == 0 then
			love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
			love.graphics.draw(controlsImg, 0+39-8, 30+8+100, 0, 1, 1)
			love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
			love.graphics.draw(controlsImg, 0+39-4, 30+4+100, 0, 1, 1)
			love.graphics.setColor(level.br,level.bg,level.bb)
			love.graphics.draw(controlsImg, 0+39, 30+100, 0, 1, 1)
		elseif options.layout == 1 then
			love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
			love.graphics.draw(controls1Img, 0+39-8, 30+8+100, 0, 1, 1)
			love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
			love.graphics.draw(controls1Img, 0+39-4, 30+4+100, 0, 1, 1)
			love.graphics.setColor(level.br,level.bg,level.bb)
			love.graphics.draw(controls1Img, 0+39, 30+100, 0, 1, 1)
		end
		end
	end
	--quit print
	if quitTimer > 0 and level.current > 0 then
		love.graphics.setColor(10,10,10,210)
		love.graphics.rectangle('fill', 0, 0, 1280,720)
		love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4)
		love.graphics.draw(secondesc, 1280/2-(secondesc:getWidth()/2)-4, 720/2+4, 0, 1, 1)
		love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65)
		love.graphics.draw(secondesc, 1280/2-(secondesc:getWidth()/2)-2, 720/2+2, 0, 1, 1)
		love.graphics.setColor(level.br,level.bg,level.bb)
		love.graphics.draw(secondesc, 1280/2-(secondesc:getWidth()/2), 720/2, 0, 1, 1)
		
		love.graphics.rectangle('fill', 1280/2-(secondesc:getWidth()/2), 720/2+70, (secondesc:getWidth()/4)*quitTimer,10)
	end
	
	--sound slider
	if slidertimer > 0 then
	love.graphics.setColor(30, 30, 30, 80)
	love.graphics.rectangle('fill', (1280-800)/2-20, 80, 840, 70)
	love.graphics.setColor(level.br, level.bg, level.bb)
	love.graphics.rectangle('fill', (1280-800)/2, 100, options.volume*800, 30)
	end
	
	love.graphics.setColor(255,255,255,255*skipTimer)
	love.graphics.rectangle('fill',0,0,1280,720)

	---Overlay Shenanigans
	
	--draw overlay
	love.graphics.setColor(255,255,255,100)
	love.graphics.draw(overlayImg, 0, 0, 0,0.5,0.5)
	
if skipTimer < 0.05 then
	--Draw env alpha overlay
	for i, block in pairs(env) do
		if block.switch == player.switch or block.switch == 0 then
			if quitTimer == 0 and block.hurt == false and vortex.scale < 60 then
				love.graphics.setColor(block.r,block.g,block.b, 185)
				love.graphics.rectangle("fill", block.x, block.y, block.width, block.height)
			end
		end
	end
	--Draw player alpha overlay
	if quitTimer == 0 then
	love.graphics.setColor(player.r,player.g,player.b, 185)
	love.graphics.rectangle("fill", player.x-3, player.y-3+player.offset, player.width+8, player.height+8)
	end
	
	--quit print alpha overlay
	if quitTimer > 0 and level.current > 0 then
		love.graphics.setColor(level.br*0.4,level.bg*0.4,level.bb*0.4, 170)
		love.graphics.draw(secondesc, 1280/2-(secondesc:getWidth()/2)-4, 720/2+4, 0, 1, 1)
		love.graphics.setColor(level.br*0.65,level.bg*0.65,level.bb*0.65, 170)
		love.graphics.draw(secondesc, 1280/2-(secondesc:getWidth()/2)-2, 720/2+2, 0, 1, 1)
		love.graphics.setColor(level.br,level.bg,level.bb, 170)
		love.graphics.draw(secondesc, 1280/2-(secondesc:getWidth()/2), 720/2, 0, 1, 1)
		
		love.graphics.rectangle('fill', 1280/2-(secondesc:getWidth()/2), 720/2+70, (secondesc:getWidth()/4)*quitTimer,10)
	end
end
end